int i, k;
#if NEW_TRUNCATE == 1
int temp;
#endif

for (i = 0; i < 36; i++) rawout[i] = 0;

#if NEW_IMDCT == 0
for (i = 0; i < 36; i++) {
	#if NEW_TRUNCATE == 1
		temp = 0;
	#endif
	for (k = 0; k < 18; k++) {
		#if NEW_TRUNCATE == 1
			temp += (int)dct_in[k] * (int)table_imdct_cos[i][k];
		#else
	 		rawout[i] += fix_mul(dct_in[k], table_imdct_cos[i][k]);
// 	 		f_temp_print("haha %d, %d: di=%04X, coe=%04X, out=%04X\n", i, k, dct_in[k] & MASK, table_imdct_cos[i][k] & MASK, rawout[i] & MASK);
		#endif
	}
	#if NEW_TRUNCATE == 1
		rawout[i] = temp >> (16 - INTEGER_BITS - 1);
	#endif
}
#else
f_temp_print("// This is frame %d, gr %d, ch %d, sb %d\n", frame_count, gr_count, ch_count, sb);

for (i = 0; i < 9; i++) {
	#if NEW_TRUNCATE == 1
		temp = 0;
	#endif
	for (k = 0; k < 18; k++) {
		#if NEW_TRUNCATE == 1
			temp += (int)dct_in[k] * (int)table_imdct_cos[i][k];
		#else
	 		rawout[i] += fix_mul(dct_in[k], table_imdct_cos[i][k]);
	 		
//  	 		f_temp_print("icg %d, %d: di=%04X, coe=%04X, out=%04X\n", i, k, dct_in[k] & MASK, table_imdct_cos[i][k] & MASK, rawout[i] & MASK);
		#endif
	}
	#if NEW_TRUNCATE == 1
		rawout[i] = temp >> (16 - INTEGER_BITS - 1);
	#endif
	rawout[17-i] = -rawout[i];
	#ifdef DEBUG_IMDCT
		fprintf(icg_b4_win_fp, "%d: %0*X\n", i, DATA_WIDTH/4, rawout[i] & MASK);	
	#endif
}

for (i = 18; i < 27; i++) {
	#if NEW_TRUNCATE == 1
		temp = 0;
	#endif
	for (k = 0; k < 18; k++) {
		#if NEW_TRUNCATE == 1
			temp += (int)dct_in[k] * (int)table_imdct_cos[i][k];
		#else
	 		rawout[i] += fix_mul(dct_in[k], table_imdct_cos[i][k]);
//  	 		f_temp_print("ipg %d, %d: di=%04X, coe=%04X, out=%04X\n", i, k, dct_in[k] & MASK, table_imdct_cos[i][k] & MASK, rawout[i] & MASK);
		#endif
	}
	#if NEW_TRUNCATE == 1
		rawout[i] = temp >> (16 - INTEGER_BITS - 1);
	#endif
	rawout[53-i] = rawout[i];
	#ifdef DEBUG_IMDCT
		fprintf(ipg_b4_win_fp, "%d: %0*X\n", i, DATA_WIDTH/4, rawout[i] & MASK);	
	#endif
}
#endif

for (i = 0; i < 18; i++) {
	dct_out[i * MAX_SB] = prev_line[i] + fix_mul(rawout[i], window[i]);
//  	f_temp_print("icg %d (%d): pre=%04X, di=%04X, coe=%04X, out=%04X\n", i, i*MAX_SB+sb, prev_line[i] & MASK, rawout[i] & MASK, window[i] & MASK, dct_out[i * MAX_SB] & MASK);
	prev_line[i] = fix_mul(rawout[i+18], window[i+18]);
//  	f_temp_print("ipg %d (%d): di=%04X, coe=%04X, out=%04X\n", i, i*MAX_SB+sb, rawout[i+18] & MASK, window[i+18] & MASK, prev_line[i] & MASK);
}
