#ifndef __PRINTMEM_H__
#define __PRINTMEM_H__

#include "fixpoint.h"

void f_mem_controller(char *);
void f_mem_reset();
void f_mem_print_syn(fixed_point);
void f_mem_print_syn_remain();
void f_mem_print_param();
void f_mem_print_param_remain();
void f_mem_print_header();
void f_mem_print_end();
void f_mem_print_syn_on();
void f_mem_print_syn_off();
void f_mem_close();
void f_mem_open(char *);
void f_mem_print(const char *fmt, ...) __attribute__ ((format (printf, 1, 2)));
void f_temp_print(const char *fmt, ...) __attribute__ ((format (printf, 1, 2)));
void f_eth_print(const char *fmt, ...) __attribute__ ((format (printf, 1, 2)));
void f_eth_print_data(fixed_point);
fixed_point f_adjusted_translate_number(float);

#endif
