
int i, k;
#if NEW_TRUNCATE == 1
long long temp1, temp2, temp3;
#endif

for (i = 0; i < 36; i++) rawout[i] = 0;

for (i = 0; i < 12; i++) {
	#if NEW_TRUNCATE == 1
	temp1 = 0;
	temp2 = 0;
	temp3 = 0;
	#endif
	for (k = 0; k < 6; k++) {
		#if NEW_TRUNCATE == 1
		temp1 += (long long)dct_in[k*3] * (long long)table_imdct_short_cos[i][k];
		temp2 += (long long)dct_in[k*3+1] * (long long)table_imdct_short_cos[i][k];
		temp3 += (long long)dct_in[k*3+2] * (long long)table_imdct_short_cos[i][k];
		#else
		rawout[i*3] += fix_mul(dct_in[k*3], table_imdct_short_cos[i][k]);
		rawout[i*3+1] += fix_mul(dct_in[k*3+1], table_imdct_short_cos[i][k]);
		rawout[i*3+2] += fix_mul(dct_in[k*3+2], table_imdct_short_cos[i][k]);
		#endif
	}
	#if NEW_TRUNCATE == 1
	rawout[i*3] = temp1 >> (32 - INTEGER_BITS - 1);
	rawout[i*3+1] = temp2 >> (32 - INTEGER_BITS - 1);
	rawout[i*3+2] = temp3 >> (32 - INTEGER_BITS - 1);
	#endif
}

/*
int i;
FILE *fp;

if (ch == 0) {
fp = fopen("imdct_temp_b4_window_normal.txt", "a");
fprintf(fp, "SHORT: Frame: %d, gr %d, ch %d, SB %d\n", frame_count, gr_count, ch, sb);
for (i = 0; i < 36; i++) {
	fprintf(fp, "%2d: %04X (%d)\n", i, rawout[i], rawout[i]);
}

fclose(fp);
}
*/

for (i = 0; i < 6; i++) {
	dct_out[i * MAX_SB] = prev_line[i];
}

for (i = 6; i < 12; i++) {
	dct_out[i * MAX_SB] = prev_line[i] + fix_mul(rawout[(i-6)*3], window[i-6]);
}

for (i = 12; i < 18; i++) {
	dct_out[i * MAX_SB] = prev_line[i] + fix_mul(rawout[(i-6)*3], window[i-6]) + fix_mul(rawout[(i-12)*3+1], window[i-12]);
}

for (i = 18; i < 24; i++) {
	prev_line[i-18] = fix_mul(rawout[(i-12)*3+1], window[i-12]) + fix_mul(rawout[(i-18)*3+2], window[i-18]);
}

for (i = 24; i < 30; i++) {
	prev_line[i-18] = fix_mul(rawout[(i-18)*3+2], window[i-18]);
}

for (i = 30; i < 36; i++) {
	prev_line[i-18] = 0;
}
